/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2007</p>
 * <p>Company: </p>
 * @author Ioannis Partalas, Grigorios Tsoumakas 
 * @version 24/07/2007
 */


import java.io.*;
import java.util.*;


public class nemenyi
{
    // Table for storing the accuracies, dimension: (N x M), where N the
    // number of the datasets and M the number of algorithms.

    public double [][] accuracies;
    public double [][] accur2;

    // Table for storing the ranks, dimension: (N x M)

    public double [][] Ranks;

    public double [] averageRanks;
    public double [] averageAcc;
    public double [] averageModels;

    public double [][] meanModels;

    public double q05[]={1.960, 2.343, 2.569, 2.728, 2.850, 2.949, 3.031, 3.102, 3.164, 3.217, 3.267,0.0,0.0,0.0,0.0,0.0,0.0,0.0,3.542};
    public double q10[]={1.645, 2.052, 2.291, 2.459, 2.589, 2.693, 2.780, 2.855, 2.920, 2.977, 3.033,0.0,0.0,0.0,0.0,0.0,0.0,0.0,3.316};

    String [] fnames;

    int N;
    int M;
    double MAX=1.0;


    public void nemenyi()
    {
    }

    public void nemenyi(int n,int m)
    {
	N = n;
	M = m;
    }

    public void parseFilesWithResults(String [] filename,String path,int dataset)
    {
	double mean=0.0;
	int num=0;
	int num_files = filename.length;
	double mean_models = 0.0;

	try
	{
	    for(int i=0;i<num_files;i++)
	    {
		BufferedReader bf = new BufferedReader(new FileReader(path+filename[i]));

		mean = 0.0;
		num=0;
		mean_models = 0;

		String line = bf.readLine();

		while(line!=null)
		{
		    num++;
		    StringTokenizer st = new StringTokenizer(line,";");
		    String token = st.nextToken();
		    token = st.nextToken();
		    double acc = Double.parseDouble(token);
		    mean+=acc;
		    token = st.nextToken();
		    int mm = Integer.parseInt(token);
		    mean_models+=mm;
		    line = bf.readLine();
		}
		mean/=num;
		mean_models/=num;
		mean = Math.round(mean*1000)/1000.0;
		accuracies[dataset][i] = mean;
		meanModels[dataset][i] = mean_models;
		bf.close();
	    }
	    System.out.println(Arrays.toString(accuracies[dataset]));
	}
	catch(Exception ex){
	    System.out.println(ex);
	    ex.printStackTrace();
	}
    }

    /*
       Read the accuracies for all datasets.

       Params---

       String file: file where the names of the datasets are stored
       String pathtofile: the absolute path to file
    */

    public void readAccuracies(String file,String pathtoresults,int start,int end)
    {
	try
	{
	    BufferedReader bf = new BufferedReader(new FileReader(file));
	    int i=0;

	    String fn = bf.readLine();

	    
	    while(fn!=null)
	    {
		fnames[i] = fn;
		String [] fnms = loadFilesWithResults(pathtoresults+fn+"/",start,end);
		//		System.out.println(i+" CALL");
		parseFilesWithResults(fnms,pathtoresults+fn+"/",i);
		i++;
		fn=bf.readLine();
	    }
	    bf.close();
	}
	catch(Exception ex){
	    System.out.println(ex);
	    ex.printStackTrace();
	}
    }

    public void readAccDirectly(String file, double storeT[][])
    {
	try
	{
	    int i,j;
	    BufferedReader bf = new BufferedReader(new FileReader(file));

	    i = 0;
	    j = 0;
	    String s = bf.readLine();

	    while(s!=null)
	    {
		StringTokenizer st = new StringTokenizer(s," ");


		for(j=0;j<M;j++)
		{
		    storeT[i][j] = Double.parseDouble(st.nextToken())/100.0;
		    storeT[i][j] = Math.round(storeT[i][j]*1000)/1000.0;
		}
		s = bf.readLine();
		i++;
		if( i==N)
		    break;
	    }
	}
	catch(Exception ex){ex.printStackTrace();System.out.println(ex);}
    }

    public int [] nextMaxIndexes(double []acc,double max)
    {
	int [] ids=new int[acc.length];
	int j=0;
	double m=0.0;

	// Find the max

	for(int i=0;i<acc.length;i++)
	   if(acc[i]<max && m<acc[i])
	       m = acc[i];

	for(int i=0;i<acc.length;i++)
	    if(acc[i]==m)
	    {
		ids[j]=i;
		j++;
	    }

	int [] rids = new int[j];
	for(int i=0;i<j;i++)
	{
	    rids[i] = ids[i];
	}
	MAX = acc[rids[0]];
	//System.exit(0);

	return rids;
    }

    public void calculateRanks(double [][] acc)
    {
	int rank=1;
	double mean_rank;
	double max=1.0;
	int [] ids=null;

	for(int i=0;i<N;i++)
	{
	    MAX=100.0;
	    rank=1;
	    while(rank<=M)
	    {
		ids = nextMaxIndexes(acc[i],MAX);

		mean_rank=0.0;

		for(int j=0;j<ids.length;j++)
		{
		    mean_rank = mean_rank + rank;
		    rank+=1;
		}
		mean_rank/=ids.length;

		for(int j=0;j<ids.length;j++)
		{

		    mean_rank = Math.round(mean_rank*1000)/1000.0;
		    Ranks[i][ids[j]] = mean_rank;
		}
	    }
	}

    }


    public String [] loadFilesWithResults(String path,int start,int end)
    {

	File dir = new File(path);

	String [] names = dir.list();
	String [] namesFinal = new String[end-start]; 
	
	//	for(int i=0;i<names.length;i++)
	//	    System.out.println(names[i]);

	Arrays.sort(names);

//		System.out.println();
//		for(int i=0;i<names.length;i++)
//		    System.out.println(names[i]);

	for(int i=start;i<end;i++)
	    namesFinal[i-start] = names[i];

	return namesFinal;
    }


    public void calculateAverages(double [][] ranks, double [][] acc, double [][] avm)
    {
	for(int i=0;i<M;i++)
	{
	    averageRanks[i]=0.0;
	    averageAcc[i]=0.0;
	    for(int j=0;j<N;j++)
	    {
		averageRanks[i]+=ranks[j][i];
		averageAcc[i]+=acc[j][i];
		averageModels[i]+=avm[j][i];
	    }
	    averageRanks[i]/=N;
	    averageRanks[i] = Math.round(averageRanks[i]*1000)/1000.0;
	    averageAcc[i]/=N;
	    averageAcc[i] = Math.round(averageAcc[i]*1000)/1000.0;
	    averageModels[i]/=N;
	}
    }


    public void printRanks(double [][] ranks)
    {
	for(int i=0;i<N;i++)
	    System.out.println(Arrays.toString(ranks[i]));

	System.out.println();


	System.out.println(Arrays.toString(averageRanks));
    }


    public void exportResults2Tex(double [][]ranks,double [][] acc,double [][]avm,String path)
    {
	try
	{
	    File f = new File(path+"ranks-acc.txt");
	    FileWriter fw = new FileWriter(f);

	    fw.write("\\begin{table}[hbt]\n");
	    fw.write("\\begin{tabular}{");
	    for(int i=0;i<=N+1;i++)
		fw.write("c");
	    fw.write("}\n");
	
	    for(int i=0;i<N;i++)
		fw.write(" & "+fnames[i]);
	fw.write(" & Averages");
	    fw.write("\\\\");
		fw.write("\n");
	    
	    for(int i=0;i<M;i++)
	    {
		for(int j=0;j<N;j++)
		    fw.write(" & "+acc[j][i]);
		fw.write(" & "+ averageAcc[i]);
		fw.write("\\");
		fw.write("\\");
		fw.write("\n");
	    }


	    fw.write("\\end{tabular}");
	    fw.write("\\end{table}\n");

	    fw.write("\n");


	    // Print Ranks

	    fw.write("\\begin{table}[hbt]\n");
	    fw.write("\\begin{tabular}{");
	    for(int i=0;i<=N+1;i++)
		fw.write("c");
	    fw.write("}\n");

	    for(int i=0;i<N;i++)
		fw.write(" & "+fnames[i]);
	fw.write(" & Averages");
	    fw.write("\\\\");
		fw.write("\n");

	    for(int i=0;i<M;i++)
	    {
		for(int j=0;j<N;j++)
		    fw.write(" & "+ranks[j][i]);
		fw.write(" & "+averageRanks[i]);
		fw.write("\\");
		fw.write("\\");
		fw.write("\n");
	    }

	    fw.write("\\hline\n");

	    fw.write("\\end{tabular}");
	    fw.write("\\end{table}\n\n");   

	    // Print average size of ensembles

	    fw.write("\\begin{table}[hbt]\n");
	    fw.write("\\begin{tabular}{");
	    for(int i=0;i<=N+1;i++)
		fw.write("c");
	    fw.write("}\n");

	    for(int i=0;i<N;i++)
		fw.write(" & "+fnames[i]);
	fw.write(" & Averages");
	    fw.write("\\\\");
		fw.write("\n");

	    for(int i=0;i<M;i++)
	    {
		for(int j=0;j<N;j++)
		    fw.write(" & "+meanModels[j][i]);
		fw.write(" & "+averageModels[i]);
		fw.write("\\");
		fw.write("\\");
		fw.write("\n");
	    }

	    fw.write("\\hline\n");


	    fw.write("\\end{tabular}");
	    fw.write("\\end{table}\n");



	    double cd05 = calculateCD(q05);
	    double cd10 = calculateCD(q10);

	    fw.write("\n");
	    fw.write("$CD_{0.05}="+cd05+"$");
	    fw.write("\n");
	    fw.write("$CD_{0.10}="+cd10+"$");

	    fw.close();
	}
	catch(Exception ex){ex.printStackTrace(); System.out.println(ex);}
    }

    public double calculateCD(double [] cv)
    {
	double tmp = cv[M-2]*Math.sqrt(((double)M*((double)M+1))/(6*(double)N));

	return Math.round(tmp*1000)/1000.0;
    }

    public void WilcoxonOnTables(double [][]acc,double [][] accs)
    {
	double [] m1 = new double[N];
	double [] m2 = new double[N];

	for(int i=0;i<M;i++)
	{
	    for(int j=0;j<N;j++)
	    {
		m1[j] = acc[j][i];
		m2[j] = accs[j][i];
	    }

	    wilcoxon w1 = new wilcoxon();
	    w1.performTest(m1,m2);
	}
    }

    public void performWilcoxonTest(double [][]acc,int test,int ens)
    {
	double [] m1 = new double[N];
	double [] m2 = new double[N];


	int limit1;
	int start1;
	int start2;
	int limit2;
	int step;

	if(ens==1) // Homogeneous
	{
	    if(test==1)
	    {
		start1=0;
		start2=M/2;
		limit1=M/4;
		limit2=3*M/4;
		step=M/4; // Number of algorithms divided by the number of groups
	    }
	    else
	    {
		start1=0;
		start2=0;
		limit1=M/2;
		limit2=0;
		step=M/2; 
	    }
	}
	else // Heterogeneous
	{
	    start1=0;
	    start2=0;
	    limit1=M/2;
	    limit2=0;
	    step=5;
	}

	for(int i=start1;i<limit1;i++)
	{
	    for(int j=0;j<N;j++)
	    {
		m1[j] = acc[j][i];
		m2[j] = acc[j][i+step];
	    }

	   wilcoxon w1 = new wilcoxon();
	       w1.performTest(m1,m2);
	}

	for(int i=start2;i<limit2;i++)
	{
	    for(int j=0;j<N;j++)
	    {
		m1[j] = acc[j][i];
		m2[j] = acc[j][i+step];
	    }

	   wilcoxon w1 = new wilcoxon();
	    w1.performTest(m1,m2);
	}
    }

    public static void main(String[] args)
    {
	int start;
	int end;
	nemenyi test = new nemenyi();
	String pathtoresults = args[1];
	String file=args[0];

	test.N = Integer.parseInt(args[2]);
	test.M = Integer.parseInt(args[3]);
	start = Integer.parseInt(args[4]);
	end = Integer.parseInt(args[5]);
	String acc2 = args[6];


	test.accuracies = new double[test.N][test.M];
	test.accur2 = new double[test.N][test.M];
	test.meanModels = new double[test.N][test.M];
	test.Ranks = new double[test.N][test.M];
	test.averageRanks = new double[test.M];
	test.averageAcc = new double[test.M];
	test.averageModels = new double[test.M];
	test.fnames = new String[test.N];

//	test.readAccuracies(file,pathtoresults,start,end);
	test.readAccDirectly(acc2,test.accur2);
//	test.calculateRanks(test.accuracies);
	test.calculateRanks(test.accur2);
//	test.calculateAverages(test.Ranks,test.accuracies,test.meanModels);
	test.calculateAverages(test.Ranks,test.accur2,test.meanModels);

	test.printRanks(test.Ranks);
//	test.exportResults2Tex(test.Ranks,test.accuracies,test.meanModels,pathtoresults);
	test.exportResults2Tex(test.Ranks,test.accur2,test.meanModels,pathtoresults);
//	test.WilcoxonOnTables(test.accuracies,test.accur2);
//	test.performWilcoxonTest(test.accur2,1,1);
    }
}
